> For the complete documentation index, see [llms.txt](https://developer.esw.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://developer.esw.com/returns-api/grp-returns-api/virtual-events.md).

# Virtual Events

## Document Ready Callback <a href="#document-ready-callback" id="document-ready-callback"></a>

This Return Document Ready virtual event will notify consumers that a Return Document has been generated.

{% code expandable="true" %}

```json
{
   "orderReference": "string",
   "returnOrderNumber": integer,
   "documentIdentifier": "guid",
   "documentType": "enum",
   "carrierReference": "string",
   "carrierTrackingReference": "string",
   "contentType": "string"
}
```

{% endcode %}

***

## Return Processed Callback <a href="#return-processed-callback" id="return-processed-callback"></a>

This Return Processed Callback will notify consumers that a Return Order has a status of Processed (i.e. all items within the return have a accepted/rejected status)

{% code expandable="true" %}

```json
{
   "orderReference": "string",
   "returnOrderNumber": integer,
   "returnMethod": "enum",
   "paidBy": "enum",
   "returnType": "enum",
   "status": "enum",
   "returnAdminCentreCode" : "string",
   "tenantCode": "string",
   "createdOn": "dateTime",
   "lastUpdated": "dateTime",
   "carrierIdentifier":"string",
   "returnItems": [{
        "id": "guid",
        "lineItemid": integer,
        "productCode": "string",
        "productDescription":"string",
        "category": "string",
        "reasonCode": "string",
        "returnItemStatus": "enum",
        "rejectionReason":"string"
    }]
}
```

{% endcode %}


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://developer.esw.com/returns-api/grp-returns-api/virtual-events.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
